package gregtechmod.loaders.load;

import gregtechmod.GT_Mod;
import gregtechmod.api.GregTech_API;
import gregtechmod.api.enums.Materials;
import gregtechmod.api.enums.OrePrefixes;
import gregtechmod.api.items.GT_Durable_Item;
import gregtechmod.api.items.GT_File_Item;
import gregtechmod.api.items.GT_Generic_Item;
import gregtechmod.api.items.GT_Saw_Item;
import gregtechmod.api.items.GT_Screwdriver_Item;
import gregtechmod.api.items.GT_SoftHammer_Item;
import gregtechmod.api.items.GT_SolderingMetal_Item;
import gregtechmod.api.items.GT_Spray_Bug_Item;
import gregtechmod.api.items.GT_Spray_Color_Item;
import gregtechmod.api.items.GT_Spray_Foam_Item;
import gregtechmod.api.items.GT_Spray_Hardener_Item;
import gregtechmod.api.items.GT_Spray_Hydration_Item;
import gregtechmod.api.items.GT_Spray_Ice_Item;
import gregtechmod.api.items.GT_Spray_Pepper_Item;
import gregtechmod.api.util.GT_LanguageManager;
import gregtechmod.api.util.GT_Log;
import gregtechmod.api.util.GT_ModHandler;
import gregtechmod.api.util.GT_OreDictUnificator;
import gregtechmod.common.items.GT_Dataorb_Item;
import gregtechmod.common.items.GT_Debug_Item;
import gregtechmod.common.items.GT_Destructopack_Item;
import gregtechmod.common.items.GT_FluidDisplayItem;
import gregtechmod.common.items.GT_MetaItem_Cell;
import gregtechmod.common.items.GT_MetaItem_Component;
import gregtechmod.common.items.GT_MetaItem_DirtyDust;
import gregtechmod.common.items.GT_MetaItem_Dust;
import gregtechmod.common.items.GT_MetaItem_Material;
import gregtechmod.common.items.GT_MetaItem_Nugget;
import gregtechmod.common.items.GT_MetaItem_SmallDust;
import gregtechmod.common.items.GT_MetaItem_TinyDust;
import gregtechmod.common.items.GT_Mortar_Item;
import gregtechmod.common.items.GT_NeutronReflector_Item;
import gregtechmod.common.items.GT_Scanner_Item;
import gregtechmod.common.items.GT_SensorCard_Item;
import gregtechmod.common.items.GT_SensorKit_Item;
import gregtechmod.common.items.GT_Sonictron_Item;
import gregtechmod.common.items.GT_Teslastaff_Item;
import gregtechmod.common.items.GT_Vanilla_Axe;
import gregtechmod.common.items.GT_Vanilla_Hoe;
import gregtechmod.common.items.GT_Vanilla_Pickaxe;
import gregtechmod.common.items.GT_Vanilla_Shovel;
import gregtechmod.common.items.GT_Vanilla_Sword;
import net.minecraft.block.material.Material;

public class GT_ItemLoader implements Runnable {
	@Override
	public void run() {
        GT_Log.out.println("GT_Mod: Register Armor Textures.");
		int tArmorID1 = GT_Mod.gregtechproxy.addArmor("lapotronpack"), tArmorID2 = GT_Mod.gregtechproxy.addArmor("lithiumbatpack"), tArmorID3 = GT_Mod.gregtechproxy.addArmor("cloakingdevice");
		
        GT_Log.out.println("GT_Mod: Register Meta-ID Items.");
		GregTech_API.sItemList[ 0] = new GT_MetaItem_Material	(GT_Mod.sItemIDs[  0], "GT_Materials");
		GregTech_API.sItemList[ 1] = new GT_MetaItem_Dust		(GT_Mod.sItemIDs[  1], "GT_Dusts");
		GregTech_API.sItemList[ 2] = new GT_MetaItem_Cell		(GT_Mod.sItemIDs[  2], "GT_Cells");
		GregTech_API.sItemList[ 3] = new GT_MetaItem_Component	(GT_Mod.sItemIDs[  3], "GT_Components");
		GregTech_API.sItemList[ 4] = new GT_MetaItem_SmallDust	(GT_Mod.sItemIDs[  4], "GT_SmallDusts");
		GregTech_API.sItemList[ 5] = new GT_MetaItem_Nugget		(GT_Mod.sItemIDs[  5], "GT_Nuggets");
		GregTech_API.sItemList[ 6] = new GT_MetaItem_DirtyDust	(GT_Mod.sItemIDs[  6], "GT_DirtyDusts");
		GregTech_API.sItemList[ 7] = new GT_MetaItem_TinyDust	(GT_Mod.sItemIDs[  7], "GT_TinyDusts");
		
        GT_Log.out.println("GT_Mod: Adding All Sub-Items with their OreDict and LiquidDict Entries.");
		GT_MetaItem_Material.addItem(  0, "Copper Credit"			, null, "0.125 Credits", false);
		GT_MetaItem_Material.addItem(  1, "Silver Credit"			, null, "8 Credits", false);
		GT_MetaItem_Material.addItem(  2, "Gold Credit"				, null, "64 Credits", false);
		GT_MetaItem_Material.addItem(  3, "Diamond Credit"			, null, "512 Credits", false);
		GT_MetaItem_Material.addItem(  4, "Iridium Alloy Ingot"		, null, null, false);
		GT_MetaItem_Material.addItem(  5, "Hot Tungstensteel Ingot"	, OrePrefixes.ingotHot	, Materials.TungstenSteel	, false);
		GT_MetaItem_Material.addItem(  6, "Tungstensteel Ingot"		, OrePrefixes.ingot		, Materials.TungstenSteel	, false);
		GT_MetaItem_Material.addItem(  7, "Oil Berry"				, null, null, false);
		GT_MetaItem_Material.addItem(  8, "Indigo Blossom"			, null, null, false);
		GT_MetaItem_Material.addItem(  9, "Indigo Dye"				, OrePrefixes.dye		, "Blue"					, false);
		
		GT_MetaItem_Material.addItem( 13, "Magnalium Plate"			, OrePrefixes.plate		, Materials.Magnalium		, false);
		GT_MetaItem_Material.addItem( 14, "Flour"					, OrePrefixes.dust		, Materials.Wheat			, false);
		GT_MetaItem_Material.addItem( 15, "Wood Plate"				, OrePrefixes.plank		, Materials.Wood			, false);
		GT_MetaItem_Material.addItem( 16, "Iridium Ingot"			, OrePrefixes.ingot		, Materials.Iridium			, false);
		GT_MetaItem_Material.addItem( 17, "Silver Ingot"			, OrePrefixes.ingot		, Materials.Silver			, false);
		GT_MetaItem_Material.addItem( 18, "Aluminium Ingot"			, OrePrefixes.ingot		, Materials.Aluminium		, false);
		GT_MetaItem_Material.addItem( 19, "Titanium Ingot"			, OrePrefixes.ingot		, Materials.Titanium		, false);
		GT_MetaItem_Material.addItem( 20, "Chrome Ingot"			, OrePrefixes.ingot		, Materials.Chrome			, false);
		GT_MetaItem_Material.addItem( 21, "Electrum Ingot"			, OrePrefixes.ingot		, Materials.Electrum		, false);
		GT_MetaItem_Material.addItem( 22, "Tungsten Ingot"			, OrePrefixes.ingot		, Materials.Tungsten		, false);
		GT_MetaItem_Material.addItem( 23, "Lead Ingot"				, OrePrefixes.ingot		, Materials.Lead			, false);
		GT_MetaItem_Material.addItem( 24, "Zinc Ingot"				, OrePrefixes.ingot		, Materials.Zinc			, false);
		GT_MetaItem_Material.addItem( 25, "Brass Ingot"				, OrePrefixes.ingot		, Materials.Brass			, false);
		GT_MetaItem_Material.addItem( 26, "Steel Ingot"				, OrePrefixes.ingot		, Materials.Steel			, false);
		GT_MetaItem_Material.addItem( 27, "Platinum Ingot"			, OrePrefixes.ingot		, Materials.Platinum		, false);
		GT_MetaItem_Material.addItem( 28, "Nickel Ingot"			, OrePrefixes.ingot		, Materials.Nickel			, false);
		GT_MetaItem_Material.addItem( 29, "Invar Ingot"				, OrePrefixes.ingot		, Materials.Invar			, false);
		GT_MetaItem_Material.addItem( 30, "Osmium Ingot"			, OrePrefixes.ingot		, Materials.Osmium			, false);
		GT_MetaItem_Material.addItem( 31, "Antimony Ingot"			, OrePrefixes.ingot		, Materials.Antimony		, false);
		GT_MetaItem_Material.addItem( 32, "Ruby"					, OrePrefixes.gem		, Materials.Ruby			, false);
		GT_MetaItem_Material.addItem( 33, "Sapphire"				, OrePrefixes.gem		, Materials.Sapphire		, false);
		GT_MetaItem_Material.addItem( 34, "Green Sapphire"			, OrePrefixes.gem		, Materials.GreenSapphire	, false);
		GT_MetaItem_Material.addItem( 35, "Chunk of Lazurite"		, OrePrefixes.block		, Materials.Lazurite		, false);
		GT_MetaItem_Material.addItem( 36, "Silicon Plate"			, OrePrefixes.plate		, Materials.Silicon			, false);
		GT_MetaItem_Material.addItem( 37, "Olivine"					, OrePrefixes.gem		, Materials.Olivine			, false);
		GT_OreDictUnificator.add("gemPeridot", GT_MetaItem_Material.instance.getUnunifiedStack(37, 1));
		GT_MetaItem_Material.addItem( 38, "Thorium Ingot"			, OrePrefixes.ingot		, Materials.Thorium			, true);
		GT_MetaItem_Material.addItem( 39, "Plutonium Ingot"			, OrePrefixes.ingot		, Materials.Plutonium		, true);
		GT_MetaItem_Material.addItem( 40, "Magnalium Ingot"			, OrePrefixes.ingot		, Materials.Magnalium		, false);
		GT_MetaItem_Material.addItem( 41, "Soldering Alloy Ingot"	, OrePrefixes.ingot		, Materials.SolderingAlloy	, false);
		GT_MetaItem_Material.addItem( 42, "Battery Alloy Ingot"		, OrePrefixes.ingot		, Materials.BatteryAlloy	, false);
		GT_MetaItem_Material.addItem( 43, "Uranium Ingot"			, OrePrefixes.ingot		, Materials.Uranium			, true);
		GT_MetaItem_Material.addItem( 44, "Stainless Steel Ingot"	, OrePrefixes.ingot		, Materials.StainlessSteel	, false);
		GT_MetaItem_Material.addItem( 45, "Cupronickel Ingot"		, OrePrefixes.ingot		, Materials.Cupronickel		, false);
		GT_MetaItem_Material.addItem( 46, "Nichrome Ingot"			, OrePrefixes.ingot		, Materials.Nichrome		, false);
		GT_MetaItem_Material.addItem( 47, "Kanthal Ingot"			, OrePrefixes.ingot		, Materials.Kanthal			, false);
		
		GT_MetaItem_Material.addItem( 54, "Red Garnet"				, OrePrefixes.gem		, Materials.GarnetRed		, false);
		GT_OreDictUnificator.add("gemGarnet", GT_MetaItem_Material.instance.getUnunifiedStack(54, 1));
		GT_MetaItem_Material.addItem( 55, "Yellow Garnet"			, OrePrefixes.gem		, Materials.GarnetYellow	, false);
		
		GT_MetaItem_Material.addItem( 58, "Yellow Garnet Plate"		, OrePrefixes.plate		, Materials.GarnetYellow	, false);
		GT_MetaItem_Material.addItem( 59, "Red Garnet Plate"		, OrePrefixes.plate		, Materials.GarnetRed		, false);
		GT_MetaItem_Material.addItem( 60, "Oak Plank"				, null					, null						, false);
		GT_MetaItem_Material.addItem( 61, "Spruce Plank"			, null					, null						, false);
		GT_MetaItem_Material.addItem( 62, "Birch Plank"				, null					, null						, false);
		GT_MetaItem_Material.addItem( 63, "Jungle Plank"			, null					, null						, false);
		GT_MetaItem_Material.addItem( 64, "Iron Plate"				, OrePrefixes.plate		, Materials.Iron			, false);
		GT_MetaItem_Material.addItem( 65, "Gold Plate"				, OrePrefixes.plate		, Materials.Gold			, false);
		GT_MetaItem_Material.addItem( 66, "Stainless Steel Plate"	, OrePrefixes.plate		, Materials.StainlessSteel	, false);
		GT_MetaItem_Material.addItem( 67, "Tin Plate"				, OrePrefixes.plate		, Materials.Tin				, false);
		GT_MetaItem_Material.addItem( 68, "Copper Plate"			, OrePrefixes.plate		, Materials.Copper			, false);
		GT_MetaItem_Material.addItem( 69, "Silver Plate"			, OrePrefixes.plate		, Materials.Silver			, false);
		GT_MetaItem_Material.addItem( 70, "Bronze Plate"			, OrePrefixes.plate		, Materials.Bronze			, false);
		GT_MetaItem_Material.addItem( 71, "Electrum Plate"			, OrePrefixes.plate		, Materials.Electrum		, false);
		GT_MetaItem_Material.addItem( 72, "Nickel Plate"			, OrePrefixes.plate		, Materials.Nickel			, false);
		GT_MetaItem_Material.addItem( 73, "Invar Plate"				, OrePrefixes.plate		, Materials.Invar			, false);
		GT_MetaItem_Material.addItem( 74, "Lead Plate"				, OrePrefixes.plate		, Materials.Lead			, false);
		GT_MetaItem_Material.addItem( 75, "Aluminium Plate"			, OrePrefixes.plate		, Materials.Aluminium		, false);
		GT_MetaItem_Material.addItem( 76, "Chrome Plate"			, OrePrefixes.plate		, Materials.Chrome			, false);
		GT_MetaItem_Material.addItem( 77, "Titanium Plate"			, OrePrefixes.plate		, Materials.Titanium		, false);
		GT_MetaItem_Material.addItem( 78, "Steel Plate"				, OrePrefixes.plate		, Materials.Steel			, false);
		GT_MetaItem_Material.addItem( 79, "Platinum Plate"			, OrePrefixes.plate		, Materials.Platinum		, false);
		GT_MetaItem_Material.addItem( 80, "Tungsten Plate"			, OrePrefixes.plate		, Materials.Tungsten		, false);
		GT_MetaItem_Material.addItem( 81, "Brass Plate"				, OrePrefixes.plate		, Materials.Brass			, false);
		GT_MetaItem_Material.addItem( 82, "Zinc Plate"				, OrePrefixes.plate		, Materials.Zinc			, false);
		GT_MetaItem_Material.addItem( 83, "Tungstensteel Plate"		, OrePrefixes.plate		, Materials.TungstenSteel	, false);
		GT_MetaItem_Material.addItem( 84, "Osmium Plate"			, OrePrefixes.plate		, Materials.Osmium			, false);
		GT_MetaItem_Material.addItem( 85, "Iridium Plate"			, OrePrefixes.plate		, Materials.Iridium			, false);
		GT_MetaItem_Material.addItem( 86, "Battery Alloy Plate"		, OrePrefixes.plate		, Materials.BatteryAlloy	, false);
		GT_MetaItem_Material.addItem( 87, "Diamond Plate"			, OrePrefixes.plate		, Materials.Diamond			, false);
		GT_MetaItem_Material.addItem( 88, "Emerald Plate"			, OrePrefixes.plate		, Materials.Emerald			, false);
		GT_MetaItem_Material.addItem( 89, "Ruby Plate"				, OrePrefixes.plate		, Materials.Ruby			, false);
		GT_MetaItem_Material.addItem( 90, "Sapphire Plate"			, OrePrefixes.plate		, Materials.Sapphire		, false);
		GT_MetaItem_Material.addItem( 91, "Green Sapphire Plate"	, OrePrefixes.plate		, Materials.GreenSapphire	, false);
		GT_MetaItem_Material.addItem( 92, "Olivine Plate"			, OrePrefixes.plate		, Materials.Olivine			, false);
		GT_MetaItem_Material.addItem( 93, "Redstone Plate"			, OrePrefixes.plate		, Materials.Redstone		, false);
		GT_MetaItem_Material.addItem( 94, "Lapis Plate"				, OrePrefixes.plate		, Materials.Lapis			, false);
		GT_MetaItem_Material.addItem( 95, "Coal Plate"				, OrePrefixes.plate		, Materials.Coal			, false);
		GT_MetaItem_Material.addItem( 96, "Iron Rod"				, OrePrefixes.stick		, Materials.Iron			, false);
		GT_MetaItem_Material.addItem( 97, "Gold Rod"				, OrePrefixes.stick		, Materials.Gold			, false);
		GT_MetaItem_Material.addItem( 98, "Stainless Steel Rod"		, OrePrefixes.stick		, Materials.StainlessSteel	, false);
		GT_MetaItem_Material.addItem( 99, "Tin Rod"					, OrePrefixes.stick		, Materials.Tin				, false);
		GT_MetaItem_Material.addItem(100, "Copper Rod"				, OrePrefixes.stick		, Materials.Copper			, false);
		GT_MetaItem_Material.addItem(101, "Silver Rod"				, OrePrefixes.stick		, Materials.Silver			, false);
		GT_MetaItem_Material.addItem(102, "Bronze Rod"				, OrePrefixes.stick		, Materials.Bronze			, false);
		GT_MetaItem_Material.addItem(103, "Electrum Rod"			, OrePrefixes.stick		, Materials.Electrum		, false);
		GT_MetaItem_Material.addItem(104, "Nickel Rod"				, OrePrefixes.stick		, Materials.Nickel			, false);
		GT_MetaItem_Material.addItem(105, "Invar Rod"				, OrePrefixes.stick		, Materials.Invar			, false);
		GT_MetaItem_Material.addItem(106, "Lead Rod"				, OrePrefixes.stick		, Materials.Lead			, false);
		GT_MetaItem_Material.addItem(107, "Aluminium Rod"			, OrePrefixes.stick		, Materials.Aluminium		, false);
		GT_MetaItem_Material.addItem(108, "Chrome Rod"				, OrePrefixes.stick		, Materials.Chrome			, false);
		GT_MetaItem_Material.addItem(109, "Titanium Rod"			, OrePrefixes.stick		, Materials.Titanium		, false);
		GT_MetaItem_Material.addItem(110, "Steel Rod"				, OrePrefixes.stick		, Materials.Steel			, false);
		GT_MetaItem_Material.addItem(111, "Platinum Rod"			, OrePrefixes.stick		, Materials.Platinum		, false);
		GT_MetaItem_Material.addItem(112, "Tungsten Rod"			, OrePrefixes.stick		, Materials.Tungsten		, false);
		GT_MetaItem_Material.addItem(113, "Brass Rod"				, OrePrefixes.stick		, Materials.Brass			, false);
		GT_MetaItem_Material.addItem(114, "Zinc Rod"				, OrePrefixes.stick		, Materials.Zinc			, false);
		GT_MetaItem_Material.addItem(115, "Tungstensteel Rod"		, OrePrefixes.stick		, Materials.TungstenSteel	, false);
		GT_MetaItem_Material.addItem(116, "Osmium Rod"				, OrePrefixes.stick		, Materials.Osmium			, false);
		GT_MetaItem_Material.addItem(117, "Iridium Rod"				, OrePrefixes.stick		, Materials.Iridium			, false);
		
		GT_MetaItem_Material.addItem(256, "Diamond Lense"			, OrePrefixes.lense		, Materials.Diamond			, false);
		GT_MetaItem_Material.addItem(257, "Ruby Lense"				, OrePrefixes.lense		, Materials.Ruby			, false);
		GT_MetaItem_Material.addItem(258, "Emerald Lense"			, OrePrefixes.lense		, Materials.Emerald			, false);
		GT_MetaItem_Material.addItem(259, "Sapphire Lense"			, OrePrefixes.lense		, Materials.Sapphire		, false);
		GT_MetaItem_Material.addItem(260, "Green Sapphire Lense"	, OrePrefixes.lense		, Materials.GreenSapphire	, false);
		GT_MetaItem_Material.addItem(261, "Yellow Garnet Lense"		, OrePrefixes.lense		, Materials.GarnetYellow	, false);
		GT_MetaItem_Material.addItem(262, "Red Garnet Lense"		, OrePrefixes.lense		, Materials.GarnetRed		, false);
		GT_MetaItem_Material.addItem(263, "Olivine Lense"			, OrePrefixes.lense		, Materials.Olivine			, false);
		GT_MetaItem_Material.addItem(264, "Amber Lense"				, OrePrefixes.lense		, Materials.Amber			, false);
		GT_MetaItem_Material.addItem(265, "Tanzanite Lense"			, OrePrefixes.lense		, Materials.Tanzanite		, false);
		GT_MetaItem_Material.addItem(266, "Topaz Lense"				, OrePrefixes.lense		, Materials.Topaz			, false);

		GT_MetaItem_Material.addItem(320, "Iron Bolt"				, OrePrefixes.bolt		, Materials.Iron			, false);
		GT_MetaItem_Material.addItem(321, "Gold Bolt"				, OrePrefixes.bolt		, Materials.Gold			, false);
		GT_MetaItem_Material.addItem(322, "Stainless Steel Bolt"	, OrePrefixes.bolt		, Materials.StainlessSteel	, false);
		GT_MetaItem_Material.addItem(323, "Tin Bolt"				, OrePrefixes.bolt		, Materials.Tin				, false);
		GT_MetaItem_Material.addItem(324, "Copper Bolt"				, OrePrefixes.bolt		, Materials.Copper			, false);
		GT_MetaItem_Material.addItem(325, "Silver Bolt"				, OrePrefixes.bolt		, Materials.Silver			, false);
		GT_MetaItem_Material.addItem(326, "Bronze Bolt"				, OrePrefixes.bolt		, Materials.Bronze			, false);
		GT_MetaItem_Material.addItem(327, "Electrum Bolt"			, OrePrefixes.bolt		, Materials.Electrum		, false);
		GT_MetaItem_Material.addItem(328, "Nickel Bolt"				, OrePrefixes.bolt		, Materials.Nickel			, false);
		GT_MetaItem_Material.addItem(329, "Invar Bolt"				, OrePrefixes.bolt		, Materials.Invar			, false);
		GT_MetaItem_Material.addItem(330, "Lead Bolt"				, OrePrefixes.bolt		, Materials.Lead			, false);
		GT_MetaItem_Material.addItem(331, "Aluminium Bolt"			, OrePrefixes.bolt		, Materials.Aluminium		, false);
		GT_MetaItem_Material.addItem(332, "Chrome Bolt"				, OrePrefixes.bolt		, Materials.Chrome			, false);
		GT_MetaItem_Material.addItem(333, "Titanium Bolt"			, OrePrefixes.bolt		, Materials.Titanium		, false);
		GT_MetaItem_Material.addItem(334, "Steel Bolt"				, OrePrefixes.bolt		, Materials.Steel			, false);
		GT_MetaItem_Material.addItem(335, "Platinum Bolt"			, OrePrefixes.bolt		, Materials.Platinum		, false);
		GT_MetaItem_Material.addItem(336, "Tungsten Bolt"			, OrePrefixes.bolt		, Materials.Tungsten		, false);
		GT_MetaItem_Material.addItem(337, "Brass Bolt"				, OrePrefixes.bolt		, Materials.Brass			, false);
		GT_MetaItem_Material.addItem(338, "Zinc Bolt"				, OrePrefixes.bolt		, Materials.Zinc			, false);
		GT_MetaItem_Material.addItem(339, "Tungstensteel Bolt"		, OrePrefixes.bolt		, Materials.TungstenSteel	, false);
		GT_MetaItem_Material.addItem(340, "Osmium Bolt"				, OrePrefixes.bolt		, Materials.Osmium			, false);
		GT_MetaItem_Material.addItem(341, "Iridium Bolt"			, OrePrefixes.bolt		, Materials.Iridium			, false);

		GT_MetaItem_Material.addItem(384, "Iron Screw"				, OrePrefixes.screw		, Materials.Iron			, false);
		GT_MetaItem_Material.addItem(385, "Gold Screw"				, OrePrefixes.screw		, Materials.Gold			, false);
		GT_MetaItem_Material.addItem(386, "Stainless Steel Screw"	, OrePrefixes.screw		, Materials.StainlessSteel	, false);
		GT_MetaItem_Material.addItem(387, "Tin Screw"				, OrePrefixes.screw		, Materials.Tin				, false);
		GT_MetaItem_Material.addItem(388, "Copper Screw"			, OrePrefixes.screw		, Materials.Copper			, false);
		GT_MetaItem_Material.addItem(389, "Silver Screw"			, OrePrefixes.screw		, Materials.Silver			, false);
		GT_MetaItem_Material.addItem(390, "Bronze Screw"			, OrePrefixes.screw		, Materials.Bronze			, false);
		GT_MetaItem_Material.addItem(391, "Electrum Screw"			, OrePrefixes.screw		, Materials.Electrum		, false);
		GT_MetaItem_Material.addItem(392, "Nickel Screw"			, OrePrefixes.screw		, Materials.Nickel			, false);
		GT_MetaItem_Material.addItem(393, "Invar Screw"				, OrePrefixes.screw		, Materials.Invar			, false);
		GT_MetaItem_Material.addItem(394, "Lead Screw"				, OrePrefixes.screw		, Materials.Lead			, false);
		GT_MetaItem_Material.addItem(395, "Aluminium Screw"			, OrePrefixes.screw		, Materials.Aluminium		, false);
		GT_MetaItem_Material.addItem(396, "Chrome Screw"			, OrePrefixes.screw		, Materials.Chrome			, false);
		GT_MetaItem_Material.addItem(397, "Titanium Screw"			, OrePrefixes.screw		, Materials.Titanium		, false);
		GT_MetaItem_Material.addItem(398, "Steel Screw"				, OrePrefixes.screw		, Materials.Steel			, false);
		GT_MetaItem_Material.addItem(399, "Platinum Screw"			, OrePrefixes.screw		, Materials.Platinum		, false);
		GT_MetaItem_Material.addItem(400, "Tungsten Screw"			, OrePrefixes.screw		, Materials.Tungsten		, false);
		GT_MetaItem_Material.addItem(401, "Brass Screw"				, OrePrefixes.screw		, Materials.Brass			, false);
		GT_MetaItem_Material.addItem(402, "Zinc Screw"				, OrePrefixes.screw		, Materials.Zinc			, false);
		GT_MetaItem_Material.addItem(403, "Tungstensteel Screw"		, OrePrefixes.screw		, Materials.TungstenSteel	, false);
		GT_MetaItem_Material.addItem(404, "Osmium Screw"			, OrePrefixes.screw		, Materials.Osmium			, false);
		GT_MetaItem_Material.addItem(405, "Iridium Screw"			, OrePrefixes.screw		, Materials.Iridium			, false);
		
		GT_MetaItem_Material.addItem(448, "Iron Round"				, OrePrefixes.round		, Materials.Iron			, false);
		GT_MetaItem_Material.addItem(449, "Gold Round"				, OrePrefixes.round		, Materials.Gold			, false);
		GT_MetaItem_Material.addItem(450, "Stainless Steel Round"	, OrePrefixes.round		, Materials.StainlessSteel	, false);
		GT_MetaItem_Material.addItem(451, "Tin Round"				, OrePrefixes.round		, Materials.Tin				, false);
		GT_MetaItem_Material.addItem(452, "Copper Round"			, OrePrefixes.round		, Materials.Copper			, false);
		GT_MetaItem_Material.addItem(453, "Silver Round"			, OrePrefixes.round		, Materials.Silver			, false);
		GT_MetaItem_Material.addItem(454, "Bronze Round"			, OrePrefixes.round		, Materials.Bronze			, false);
		GT_MetaItem_Material.addItem(455, "Electrum Round"			, OrePrefixes.round		, Materials.Electrum		, false);
		GT_MetaItem_Material.addItem(456, "Nickel Round"			, OrePrefixes.round		, Materials.Nickel			, false);
		GT_MetaItem_Material.addItem(457, "Invar Round"				, OrePrefixes.round		, Materials.Invar			, false);
		GT_MetaItem_Material.addItem(458, "Lead Round"				, OrePrefixes.round		, Materials.Lead			, false);
		GT_MetaItem_Material.addItem(459, "Aluminium Round"			, OrePrefixes.round		, Materials.Aluminium		, false);
		GT_MetaItem_Material.addItem(460, "Chrome Round"			, OrePrefixes.round		, Materials.Chrome			, false);
		GT_MetaItem_Material.addItem(461, "Titanium Round"			, OrePrefixes.round		, Materials.Titanium		, false);
		GT_MetaItem_Material.addItem(462, "Steel Round"				, OrePrefixes.round		, Materials.Steel			, false);
		GT_MetaItem_Material.addItem(463, "Platinum Round"			, OrePrefixes.round		, Materials.Platinum		, false);
		GT_MetaItem_Material.addItem(464, "Tungsten Round"			, OrePrefixes.round		, Materials.Tungsten		, false);
		GT_MetaItem_Material.addItem(465, "Brass Round"				, OrePrefixes.round		, Materials.Brass			, false);
		GT_MetaItem_Material.addItem(466, "Zinc Round"				, OrePrefixes.round		, Materials.Zinc			, false);
		GT_MetaItem_Material.addItem(467, "Tungstensteel Round"		, OrePrefixes.round		, Materials.TungstenSteel	, false);
		GT_MetaItem_Material.addItem(468, "Osmium Round"			, OrePrefixes.round		, Materials.Osmium			, false);
		GT_MetaItem_Material.addItem(469, "Iridium Round"			, OrePrefixes.round		, Materials.Iridium			, false);
		
		GT_MetaItem_Nugget.addItem( 16, Materials.Iridium		, false);
		GT_MetaItem_Nugget.addItem( 17, Materials.Silver		, false);
		GT_MetaItem_Nugget.addItem( 18, Materials.Aluminium		, false);
		GT_MetaItem_Nugget.addItem( 19, Materials.Titanium		, false);
		GT_MetaItem_Nugget.addItem( 20, Materials.Chrome		, false);
		GT_MetaItem_Nugget.addItem( 21, Materials.Electrum		, false);
		GT_MetaItem_Nugget.addItem( 22, Materials.Tungsten		, false);
		GT_MetaItem_Nugget.addItem( 23, Materials.Lead			, false);
		GT_MetaItem_Nugget.addItem( 24, Materials.Zinc			, false);
		GT_MetaItem_Nugget.addItem( 25, Materials.Brass			, false);
		GT_MetaItem_Nugget.addItem( 26, Materials.Steel			, false);
		GT_MetaItem_Nugget.addItem( 27, Materials.Platinum		, false);
		GT_MetaItem_Nugget.addItem( 28, Materials.Nickel		, false);
		GT_MetaItem_Nugget.addItem( 29, Materials.Invar			, false);
		GT_MetaItem_Nugget.addItem( 30, Materials.Osmium		, false);
		GT_MetaItem_Nugget.addItem( 31, Materials.Antimony		, false);
		
		GT_MetaItem_Nugget.addItem(241, Materials.Iron			, false);
		GT_MetaItem_Nugget.addItem(243, Materials.Copper		, false);
		GT_MetaItem_Nugget.addItem(244, Materials.Tin			, false);
		GT_MetaItem_Nugget.addItem(245, Materials.Bronze		, false);
		
		GT_MetaItem_Dust.addItem(  0, "Ender Pearl Dust"		, Materials.EnderPearl		, false);
		GT_MetaItem_Dust.addItem(  1, "Ender Eye Dust"			, Materials.EnderEye		, false);
		GT_MetaItem_Dust.addItem(  2, "Lazurite Dust"			, Materials.Lazurite		, false);
		GT_MetaItem_Dust.addItem(  3, "Pyrite Dust"				, Materials.Pyrite			, false);
		GT_MetaItem_Dust.addItem(  4, "Calcite Dust"			, Materials.Calcite			, false);
		GT_MetaItem_Dust.addItem(  5, "Sodalite Dust"			, Materials.Sodalite		, false);
		GT_MetaItem_Dust.addItem(  6, "Netherrack Dust"			, Materials.Netherrack		, false);
		GT_MetaItem_Dust.addItem(  7, "Flint Dust"				, Materials.Flint			, false);
		GT_MetaItem_Dust.addItem(  8, "Sulfur Dust"				, Materials.Sulfur			, false);
		GT_MetaItem_Dust.addItem(  9, "Saltpeter Dust"			, Materials.Saltpeter		, false);
		GT_MetaItem_Dust.addItem( 10, "Endstone Dust"			, Materials.Endstone		, false);
		GT_MetaItem_Dust.addItem( 11, "Cinnabar Dust"			, Materials.Cinnabar		, false);
		GT_MetaItem_Dust.addItem( 12, "Manganese Dust"			, Materials.Manganese		, false);
		GT_MetaItem_Dust.addItem( 13, "Magnesium Dust"			, Materials.Magnesium		, false);
		GT_MetaItem_Dust.addItem( 14, "Sphalerite Dust"			, Materials.Sphalerite		, false);
		GT_MetaItem_Dust.addItem( 15, "Wood Pulp"				, Materials.Wood			, false);
		GT_OreDictUnificator.add("pulpWood", GT_MetaItem_Dust.instance.getUnunifiedStack(15, 1));
		GT_OreDictUnificator.add("pulpWood", GT_ModHandler.getTEItem("sawdust", 1));
		GT_MetaItem_Dust.addItem( 16, "Uranium Dust"			, Materials.Uranium			,  true);
		GT_MetaItem_Dust.addItem( 17, "Bauxite Dust"			, Materials.Bauxite			, false);
		GT_MetaItem_Dust.addItem( 18, "Aluminium Dust"			, Materials.Aluminium		, false);
		GT_MetaItem_Dust.addItem( 19, "Titanium Dust"			, Materials.Titanium		, false);
		GT_MetaItem_Dust.addItem( 20, "Chrome Dust"				, Materials.Chrome			, false);
		GT_MetaItem_Dust.addItem( 21, "Electrum Dust"			, Materials.Electrum		, false);
		GT_MetaItem_Dust.addItem( 22, "Tungsten Dust"			, Materials.Tungsten		, false);
		GT_MetaItem_Dust.addItem( 23, "Lead Dust"				, Materials.Lead			, false);
		GT_MetaItem_Dust.addItem( 24, "Zinc Dust"				, Materials.Zinc			, false);
		GT_MetaItem_Dust.addItem( 25, "Brass Dust"				, Materials.Brass			, false);
		GT_MetaItem_Dust.addItem( 26, "Steel Dust"				, Materials.Steel			, false);
		GT_MetaItem_Dust.addItem( 27, "Platinum Dust"			, Materials.Platinum		, false);
		GT_MetaItem_Dust.addItem( 28, "Nickel Dust"				, Materials.Nickel			, false);
		GT_MetaItem_Dust.addItem( 29, "Invar Dust"				, Materials.Invar			, false);
		GT_MetaItem_Dust.addItem( 30, "Osmium Dust"				, Materials.Osmium			, false);
		GT_MetaItem_Dust.addItem( 31, "Antimony Dust"			, Materials.Antimony		, false);
		GT_MetaItem_Dust.addItem( 32, "Ruby Dust"				, Materials.Ruby			, false);
		GT_MetaItem_Dust.addItem( 33, "Sapphire Dust"			, Materials.Sapphire		, false);
		GT_MetaItem_Dust.addItem( 34, "Green Sapphire Dust"		, Materials.GreenSapphire	, false);
		GT_MetaItem_Dust.addItem( 35, "Emerald Dust"			, Materials.Emerald			, false);
		GT_MetaItem_Dust.addItem( 36, "Diamond Dust"			, Materials.Diamond			, false);
		GT_MetaItem_Dust.addItem( 37, "Olivine Dust"			, Materials.Olivine			, false);
		
		GT_MetaItem_Dust.addItem( 40, "Cupronickel Dust"		, Materials.Cupronickel		, false);
		GT_MetaItem_Dust.addItem( 41, "Nichrome Dust"			, Materials.Nichrome		, false);
		GT_MetaItem_Dust.addItem( 42, "Kanthal Dust"			, Materials.Kanthal			, false);
		GT_MetaItem_Dust.addItem( 43, "Stainless Steel Dust"	, Materials.StainlessSteel	, false);
		GT_MetaItem_Dust.addItem( 44, "Galena Dust"				, Materials.Galena			, false);
		GT_MetaItem_Dust.addItem( 45, "Phosphorus Dust"			, Materials.Phosphorus		, false);
		GT_MetaItem_Dust.addItem( 46, "Obsidian Dust"			, Materials.Obsidian		, false);
		GT_MetaItem_Dust.addItem( 47, "Charcoal Dust"			, Materials.Charcoal		, false);
		
		GT_MetaItem_Dust.addItem( 54, "Red Garnet Dust"			, Materials.GarnetRed		, false);
		GT_MetaItem_Dust.addItem( 55, "Yellow Garnet Dust"		, Materials.GarnetYellow	, false);
		GT_MetaItem_Dust.addItem( 56, "Pyrope Dust"				, Materials.Pyrope			, false);
		GT_MetaItem_Dust.addItem( 57, "Almandine Dust"			, Materials.Almandine		, false);
		GT_MetaItem_Dust.addItem( 58, "Spessartine Dust"		, Materials.Spessartine		, false);
		GT_MetaItem_Dust.addItem( 59, "Andradite Dust"			, Materials.Andradite		, false);
		GT_MetaItem_Dust.addItem( 60, "Grossular Dust"			, Materials.Grossular		, false);
		GT_MetaItem_Dust.addItem( 61, "Uvarovite Dust"			, Materials.Uvarovite		, false);
		GT_MetaItem_Dust.addItem( 62, "Ashes"					, Materials.Ash				, false);
		GT_MetaItem_Dust.addItem( 63, "Dark Ashes"				, Materials.DarkAsh			, false);
		GT_MetaItem_Dust.addItem( 64, "Redrock Dust"			, Materials.Redrock			, false);
		GT_MetaItem_Dust.addItem( 65, "Marble Dust"				, Materials.Marble			, false);
		GT_MetaItem_Dust.addItem( 66, "Basalt Dust"				, Materials.Basalt			, false);
		GT_MetaItem_Dust.addItem( 67, "Iridium Dust"			, Materials.Iridium			, false);
		
		GT_MetaItem_Dust.addItem( 80, "Thorium Dust"			, Materials.Thorium			,  true);
		GT_MetaItem_Dust.addItem( 81, "Plutonium Dust"			, Materials.Plutonium		,  true);
		
		GT_MetaItem_Dust.addItem(238, "Lapis Lazuli Dust"		, Materials.Lapis			, false);
		GT_MetaItem_Dust.addItem(239, "Tetrahedrite Dust"		, Materials.Tetrahedrite	, false);
		GT_MetaItem_Dust.addItem(240, "Coal Dust"				, Materials.Coal			, false);
		GT_MetaItem_Dust.addItem(241, "Iron Dust"				, Materials.Iron			, false);
		GT_MetaItem_Dust.addItem(242, "Gold Dust"				, Materials.Gold			, false);
		GT_MetaItem_Dust.addItem(243, "Copper Dust"				, Materials.Copper			, false);
		GT_MetaItem_Dust.addItem(244, "Tin Dust"				, Materials.Tin				, false);
		GT_MetaItem_Dust.addItem(245, "Bronze Dust"				, Materials.Bronze			, false);
		GT_MetaItem_Dust.addItem(246, "Silver Dust"				, Materials.Silver			, false);
		GT_MetaItem_Dust.addItem(247, "Clay Dust"				, Materials.Clay			, false);
		
		GT_MetaItem_SmallDust.addItem(248, "Gunpowder"			, Materials.Gunpowder		, false);
		GT_MetaItem_SmallDust.addItem(249, "Redstone Dust"		, Materials.Redstone		, false);
		GT_MetaItem_SmallDust.addItem(250, "Glowstone Dust"		, Materials.Glowstone		, false);
		GT_MetaItem_SmallDust.addItem(251, "Blaze Powder"		, Materials.Blaze			, false);
		
		GT_MetaItem_Cell.addItem(  0, "Hydrogen Cell"			, "molecule_1h"			, false, Materials.Hydrogen);
		GT_MetaItem_Cell.addItem(  1, "Deuterium Cell"			, "molecule_1d"			, false, Materials.Deuterium);
		GT_MetaItem_Cell.addItem(  2, "Tritium Cell"			, "molecule_1t"			, false, Materials.Tritium);
		GT_MetaItem_Cell.addItem(  3, "Helium Cell"				, "molecule_1he"		, false, Materials.Helium);
		GT_MetaItem_Cell.addItem(  4, "Wolframium Cell"			, "molecule_1w"			, false, Materials.Tungsten);
		GT_MetaItem_Cell.addItem(  5, "Lithium Cell"			, "molecule_1li"		, false, Materials.Lithium);
		GT_MetaItem_Cell.addItem(  6, "Helium-3 Cell"			, "molecule_1he3"		, false, Materials.Helium_3);
		GT_MetaItem_Cell.addItem(  7, "Silicon Cell"			, "molecule_1si"		, false, Materials.Silicon);
		GT_MetaItem_Cell.addItem(  8, "Carbon Cell"				, "molecule_1c"			, false, Materials.Carbon);
		GT_MetaItem_Cell.addItem(  9, "Methane Cell"			, "molecule_1me"		, false, Materials.Methane);
		GT_MetaItem_Cell.addItem( 10, "Berylium Cell"			, "molecule_1be"		, false, Materials.Beryllium);
		GT_MetaItem_Cell.addItem( 11, "Calcium Cell"			, "molecule_1ca"		, false, Materials.Calcium);
		GT_MetaItem_Cell.addItem( 12, "Sodium Cell"				, "molecule_1na"		, false, Materials.Sodium);
		GT_MetaItem_Cell.addItem( 13, "Chlorine Cell"			, "molecule_1cl"		, false, Materials.Chlorine);
		GT_MetaItem_Cell.addItem( 14, "Potassium Cell"			, "molecule_1k"			, false, Materials.Potassium);
		GT_MetaItem_Cell.addItem( 15, "Nitrogen Cell"			, "molecule_1n"			, false, Materials.Nitrogen);
		GT_MetaItem_Cell.addItem( 16, "Mercury Cell"			, "molecule_1hg"		, false, Materials.Mercury);
		GT_MetaItem_Cell.addItem( 17, "Oil Cell"				, ""					, false, Materials.Oil);
		GT_MetaItem_Cell.addItem( 18, "Diesel Cell"				, ""					, false, Materials.Fuel);
		GT_MetaItem_Cell.addItem( 19, "Ethanol Cell"			, ""					, false, Materials.Ethanol);
		GT_MetaItem_Cell.addItem( 20, "Biomass Cell"			, ""					, false, Materials.Biomass);
		
		GT_MetaItem_Cell.addItem( 22, "Nitro-Diesel Cell"		, ""					, false, Materials.NitroFuel);
		GT_MetaItem_Cell.addItem( 23, "Ice Cell"				, ""					, false, Materials.Ice);
		GT_OreDictUnificator.addToBlacklist(GT_MetaItem_Cell.instance.getStack(23, 1));
		GT_MetaItem_Cell.addItem( 24, "Seed Oil Cell"			, ""					, false, Materials.SeedOil);
		
		GT_MetaItem_Cell.addItem( 32, "Sodium Persulfate Cell"	, "molecule_2na_2s_8o"	, false, Materials.SodiumPersulfate);
		GT_MetaItem_Cell.addItem( 33, "Calcium Carbonate Cell"	, "molecule_1ca_1c_3o"	, false, Materials.Calcite);
		GT_MetaItem_Cell.addItem( 34, "Glyceryl Cell"			, "molecule_3c_5h_3n_9o", false, Materials.Glyceryl);
		GT_MetaItem_Cell.addItem( 35, "Nitro-Coalfuel Cell"		, ""					, false, Materials.NitroCoalFuel);
		GT_MetaItem_Cell.addItem( 36, "Sulfur Cell"				, "molecule_1s"			, false, Materials.Sulfur);
		GT_MetaItem_Cell.addItem( 37, "Sodium Sulfide Cell"		, "molecule_1na_1s"		, false, Materials.SodiumSulfide);
		GT_MetaItem_Cell.addItem( 38, "Nitrogen Dioxide Cell"	, "molecule_1n_2o"		, false, Materials.NitrogenDioxide);
		GT_MetaItem_Cell.addItem( 39, "Nitrocarbon Cell"		, "molecule_1n_1c"		, false, Materials.NitroCarbon);
		GT_MetaItem_Cell.addItem( 40, "Sulfuric Acid Cell"		, "molecule_2h_1s_4o"	, false, Materials.SulfuricAcid);
		
		GT_MetaItem_Cell.addItem(131, "Helium Plasma Cell"		, "plasma_1he"			, true , Materials.Helium);
		
		GT_MetaItem_Component.addItem( 0, "Energy Flow Circuit"			, "craftingCircuitTier07"		, "Manages large amounts of Energy");
		GT_MetaItem_Component.addItem( 1, "Data Control Circuit"		, "calclavia:CIRCUIT_T3"		, "Basic Computer Processor");
		GT_MetaItem_Component.addItem( 2, "Superconductor"				, "craftingSuperconductor"		, "Conducts Energy losslessly");
		GT_MetaItem_Component.addItem( 3, "Data Storage Circuit"		, "craftingCircuitTier05"		, "Stores Data");
		GT_MetaItem_Component.addItem( 4, "Computer Monitor"			, "craftingMonitorTier02"		, "Displays things");
		GT_MetaItem_Component.addItem( 5, "Conveyor Module"				, "craftingConveyor"			, "Moves Items around");
		GT_MetaItem_Component.addItem( 6, "Pump Module"					, "craftingPump"				, "Moves Liquids around");
		GT_MetaItem_Component.addItem( 7, "Solar Panel"					, "craftingSolarPanel"			, "Makes Energy from Sun");
		GT_MetaItem_Component.addItem( 8, "Item Transport Valve"		, "craftingItemValve"			, "Moves Items and Liquids at once!");
		GT_MetaItem_Component.addItem( 9, "Drain"						, "craftingDrain"				, "Collects Liquids and Rain");
		GT_MetaItem_Component.addItem(10, "Redstone Liquid Detector"	, "craftingLiquidMeter"			, "Outputs Redstone depending on stored Liquids");
		GT_MetaItem_Component.addItem(11, "Redstone Item Detector"		, "craftingItemMeter"			, "Outputs Redstone depending on stored Items");
		GT_MetaItem_Component.addItem(12, "Energy Crystal Upgrade"		, "crafting1kkEUStore"			, "Adds 1 Million EU to the Energy Capacity");
		GT_MetaItem_Component.addItem(13, "Lapotron Crystal Upgrade"	, "crafting10kkEUStore"			, "Adds 10 Million EU to the Energy Capacity");
		GT_MetaItem_Component.addItem(14, "Energy Orb Upgrade"			, "crafting100kkEUStore"		, "Adds 100 Million EU to the Energy Capacity");
		GT_MetaItem_Component.addItem(15, "Redstone Energy Meter"		, "craftingEnergyMeter"			, "Outputs Redstone depending on stored Energy");
		GT_MetaItem_Component.addItem(16, "BrainTech Aerospace Advanced Reinforced Duct Tape FAL-84", "craftingDuctTape", "If you can't fix it with this, use more of it!");
		GT_MetaItem_Component.addItem(17, "Diamond Sawblade"			, "craftingDiamondBlade"		, "Caution! This is very sharp.");
		GT_MetaItem_Component.addItem(18, "Diamond Grinder"				, "craftingGrinder"				, "Fancy Grinding Head");
		GT_MetaItem_Component.addItem(19, "Kanthal Heating Coil"		, "craftingHeatingCoilTier01"	, "Standard Heating Coil"); //33% Iron 33% Chrome 33% Aluminium
		GT_MetaItem_Component.addItem(20, "Nichrome Heating Coil"		, "craftingHeatingCoilTier02"	, "Advanced Heating Coil"); //20% Chrome 80% Nickel
		GT_MetaItem_Component.addItem(21, "Cupronickel Heating Coil"	, "craftingHeatingCoilTier00"	, "Cheap and simple Heating Coil"); //50% Copper 50% Nickel
		GT_MetaItem_Component.addItem(22, "Machine Parts"				, "craftingMachineParts"		, "Random Machine Parts");
		GT_MetaItem_Component.addItem(23, "Wolframium Grinder"			, "craftingGrinder"				, "Regular Grinding Head");
		GT_MetaItem_Component.addItem(24, "Advanced Circuit Parts"		, "craftingCircuitPartsTier04"	, "Part of advanced Circuitry");
		GT_MetaItem_Component.addItem(25, "Pneumatic Generator Upgrade"	, "craftingPneumaticGenerator"	, "Lets Machines accept MJ at 1MJ -> 1EU (yes, that is lossy)");
		GT_MetaItem_Component.addItem(26, "Lithium Battery Upgrade"		, "craftingLiBattery"			, "Adds 100000 EU to the Energy Capacity");
		GT_OreDictUnificator.registerOre("crafting100kEUStore", GT_MetaItem_Component.instance.getUnunifiedStack( 26, 1));
		GT_MetaItem_Component.addItem(27, "HV-Transformer Upgrade"		, "craftingHVTUpgrade"			, "Higher Tier of Transformer Upgrade");
		GT_MetaItem_Component.addItem(28, "RS-Energy-Cell Upgrade"		, "craftingEnergyCellUpgrade"	, "Adds 100000 MJ to the Energy Capacity");
		GT_MetaItem_Component.addItem(29, "Quantum-Chest Upgrade"		, "craftingQuantumChestUpgrade"	, "Upgrades a Digital Chest to a Quantum Chest");
		GT_MetaItem_Component.addItem(30, "Active Machine Detector"		, "craftingWorkDetector"		, "Emits Restone if the Machine has work");
		GT_MetaItem_Component.addItem(31, "Redstone Machine Controller"	, "craftingWorkController"		, "This can control Machines with Redstone");
		GT_MetaItem_Component.addItem(32, "Aluminium Machine Hull"		, "craftingRawMachineTier01"	, "Machine Block");
		GT_MetaItem_Component.addItem(33, "Bronze Machine Hull"			, "craftingRawMachineTier00"	, "Cheap Machine Block");
		GT_MetaItem_Component.addItem(34, "Brass Machine Hull"			, "craftingRawMachineTier00"	, "Cheap Machine Block");
		GT_MetaItem_Component.addItem(35, "Steel Machine Hull"			, "craftingRawMachineTier02"	, "Advanced Machine Block");
		GT_MetaItem_Component.addItem(36, "Titanium Machine Hull"		, "craftingRawMachineTier03"	, "Very Advanced Machine Block");
		GT_MetaItem_Component.addItem(37, "Iron Machine Hull"			, "craftingRawMachineTier01"	, "Machine Block");
		GT_MetaItem_Component.addItem(38, "Tungstensteel Machine Hull"	, "craftingRawMachineTier03"	, "Very Advanced Machine Block");
		GT_MetaItem_Component.addItem(39, "Stainless Machine Hull"		, "craftingRawMachineTier02"	, "Advanced Machine Block");
		
		GT_MetaItem_Component.addItem(48, "Basic Circuit Board"			, "craftingCircuitBoardTier02"			, "Just a simple Circuit Plate");
		GT_MetaItem_Component.addItem(49, "Advanced Circuit Board"		, "craftingCircuitBoardTier04"			, "Standard Circuit Plate");
		GT_MetaItem_Component.addItem(50, "Processor Circuit Board"		, "craftingCircuitBoardTier06"			, "Highly advanced Circuit Plate");
		GT_MetaItem_Component.addItem(51, "Bronze Turbine Blade"		, "craftingTurbineBladeBronze"			, "Heavy Turbine Blade");
		GT_MetaItem_Component.addItem(52, "Steel Turbine Blade"			, "craftingTurbineBladeSteel"			, "Standard Turbine Blade");
		GT_MetaItem_Component.addItem(53, "Magnalium Turbine Blade"		, "craftingTurbineBladeMagnalium"		, "Light Turbine Blade");
		GT_MetaItem_Component.addItem(54, "Tungstensteel Turbine Blade"	, "craftingTurbineBladeTungstenSteel"	, "Durable Turbine Blade");
		GT_MetaItem_Component.addItem(55, "Carbon Turbine Blade"		, "craftingTurbineBladeCarbon"			, "Ultralight Turbine Blade");
		GT_MetaItem_Component.addItem(56, "Empty Spray Can"				, "craftingSprayCan"					, "Used for making Sprays and storing Colors");
		//GT_MetaItem_Component.addItem(57, "Empty Battery Hull"			, "craftingBatteryHull"					, "For making Batteries");
		//GT_MetaItem_Component.addItem(58, "Empty Fuel Can"				, "craftingFuelCan"						, "Mainly for storing Fuel");
		
		GT_MetaItem_Component.addItem(64, "Crafting Module"				, "craftingWorkBench"			, "A Workbench on a Cover");
		GT_MetaItem_Component.addItem(65, "LV Solar Panel"				, "craftingSolarPanelLV"		, "Makes Energy from Sun at 8EU/t");
		GT_MetaItem_Component.addItem(66, "MV Solar Panel"				, "craftingSolarPanelMV"		, "Makes Energy from Sun at 64 EU/t");
		GT_MetaItem_Component.addItem(67, "HV Solar Panel"				, "craftingSolarPanelHV"		, "Makes Energy from Sun at 512 EU/t");
		
		GT_MetaItem_Component.addItem(80, "Steam Upgrade"				, "craftingSteamUpgrade"		, "Lets Machines consume Steam at 2mB per EU (lossless)");
		GT_MetaItem_Component.addItem(81, "Steam Tank"					, "craftingSteamTank"			, "Increases Steam Capacity by 64 Buckets");
		GT_MetaItem_Component.addItem(82, "Redstone Receiver (IN)"		, "craftingRedstoneReceiver"	, "Receives Signals into the attached Machine");
		GT_MetaItem_Component.addItem(83, "Redstone Receiver (OUT)"		, "craftingRedstoneReceiver"	, "Receives Signals out of the attached Machine");
		GT_MetaItem_Component.addItem(84, "Redstone Transmitter (IN)"	, "craftingRedstoneTransmitter"	, "Transmitts Signals from the attached Machine");
		GT_MetaItem_Component.addItem(85, "Redstone Transmitter (OUT)"	, "craftingRedstoneTransmitter"	, "Transmitts Signals at the attached Machine");
		GT_MetaItem_Component.addItem(86, "Redstone Conductor"			, "craftingRedstoneConductor"	, "Throughputs Redstone to the Cover Facing");
		GT_MetaItem_Component.addItem(87, "Redstone Signalizer"			, "craftingRedstoneSignalizer"	, "Applies a constant Redstone Signal to a Machine");
		GT_MetaItem_Component.addItem(88, "Lock Upgrade"				, "craftingLock"				, "Makes a Machine private for the one, who applies the Upgrade");
		
		GT_MetaItem_Component.addItem( 96, "Iron Gear"					, "gearIron"					, "An Iron Gear");
		GT_OreDictUnificator.registerOre("craftingGearTier01"			, GT_MetaItem_Component.instance.getUnunifiedStack( 96, 1));
		GT_MetaItem_Component.addItem( 97, "Bronze Gear"				, "gearBronze"					, "A Bronze Gear");
		GT_OreDictUnificator.registerOre("craftingGearTier01"			, GT_MetaItem_Component.instance.getUnunifiedStack( 97, 1));
		GT_MetaItem_Component.addItem( 98, "Steel Gear"					, "gearSteel"					, "A Steel Gear");
		GT_OreDictUnificator.registerOre("craftingGearTier02"			, GT_MetaItem_Component.instance.getUnunifiedStack( 98, 1));
		GT_MetaItem_Component.addItem( 99, "Titanium Gear"				, "gearTitanium"				, "A Titanium Gear");
		GT_OreDictUnificator.registerOre("craftingGearTier03"			, GT_MetaItem_Component.instance.getUnunifiedStack( 99, 1));
		GT_MetaItem_Component.addItem(100, "Tungstensteel Gear"			, "gearTungstenSteel"			, "A Tungstensteel Gear");
		GT_OreDictUnificator.registerOre("craftingGearTier03"			, GT_MetaItem_Component.instance.getUnunifiedStack(100, 1));
		GT_MetaItem_Component.addItem(101, "Iridium Gear"				, "gearIridium"					, "An Iridium Gear");
		GT_OreDictUnificator.registerOre("craftingGearTier04"			, GT_MetaItem_Component.instance.getUnunifiedStack(101, 1));
		GT_MetaItem_Component.addItem(102, "Stainless Steel Gear"		, "gearStainlessSteel"			, "A Stainless Steel Gear");
		GT_OreDictUnificator.registerOre("craftingGearTier02"			, GT_MetaItem_Component.instance.getUnunifiedStack(102, 1));
		
        GT_Log.out.println("GT_Mod: Register Regular Items.");
        
        GregTech_API.sItemList[ 15] = new GT_FluidDisplayItem							(GT_Mod.sItemIDs[ 15], GT_LanguageManager.mNameListItem[ 15]);
		try {
		Class.forName("shedar.mods.ic2.nuclearcontrol.api.IRemoteSensor");
		GregTech_API.sItemList[ 16] = new GT_SensorCard_Item							(GT_Mod.sItemIDs[ 16], GT_LanguageManager.mNameListItem[ 16]);
		GregTech_API.sItemList[ 17] = new GT_SensorKit_Item								(GT_Mod.sItemIDs[ 17], GT_LanguageManager.mNameListItem[ 17]);
		} catch (Throwable e) {
	    GregTech_API.sItemList[ 16] = new GT_Generic_Item								(GT_Mod.sItemIDs[ 16], GT_LanguageManager.mNameListItem[ 16], "Nuclear Control not installed", false);
		GregTech_API.sItemList[ 17] = new GT_Generic_Item								(GT_Mod.sItemIDs[ 17], GT_LanguageManager.mNameListItem[ 17], "Nuclear Control not installed", false);
        }
		
        GregTech_API.sItemList[ 18] = GregTech_API.constructElectricArmorItem			(GT_Mod.sItemIDs[ 18], GT_LanguageManager.mNameListItem[ 18], 1000000000, Integer.MAX_VALUE, 1, 10, -1, 100.0D, true, 1, tArmorID1);
		
		GregTech_API.sItemList[ 30] = new GT_Mortar_Item								(GT_Mod.sItemIDs[ 30], GT_LanguageManager.mNameListItem[ 30],       64, GT_OreDictUnificator.get(OrePrefixes.dust, Materials.Iron, 1));
		GregTech_API.sItemList[ 31] = new GT_Generic_Item								(GT_Mod.sItemIDs[ 31], GT_LanguageManager.mNameListItem[ 31], "Used to turn Ingots into Dust");
		GregTech_API.sItemList[ 32] = new GT_Sonictron_Item								(GT_Mod.sItemIDs[ 32], GT_LanguageManager.mNameListItem[ 32]);
		GregTech_API.sItemList[ 33] = new GT_Destructopack_Item							(GT_Mod.sItemIDs[ 33], GT_LanguageManager.mNameListItem[ 33]);
		GregTech_API.sItemList[ 34] = GregTech_API.constructCoolantCellItem				(GT_Mod.sItemIDs[ 34], GT_LanguageManager.mNameListItem[ 34],    60000, 1);
		GregTech_API.sItemList[ 35] = GregTech_API.constructCoolantCellItem				(GT_Mod.sItemIDs[ 35], GT_LanguageManager.mNameListItem[ 35],   180000, 3);
		GregTech_API.sItemList[ 36] = GregTech_API.constructCoolantCellItem				(GT_Mod.sItemIDs[ 36], GT_LanguageManager.mNameListItem[ 36],   360000, 6);
		GregTech_API.sItemList[ 37] = GregTech_API.constructElectricEnergyStorageItem	(GT_Mod.sItemIDs[ 37], GT_LanguageManager.mNameListItem[ 37],100000000, 8192, 5, 37, 37);
		GregTech_API.sItemList[ 38] = GregTech_API.constructElectricArmorItem			(GT_Mod.sItemIDs[ 38], GT_LanguageManager.mNameListItem[ 38],100000000, 8192, 5,  0,   512, 0.0D, false, 1, tArmorID3);
		GregTech_API.sItemList[ 39] = GregTech_API.constructElectricDrillItem			(GT_Mod.sItemIDs[ 39], GT_LanguageManager.mNameListItem[ 39],       10, 0, 2,  7.5F,  50, -1).setElectricTier(1).setBlockBreakSound(GregTech_API.sSoundList.get(107)).setEntityHitSound(GregTech_API.sSoundList.get(107));
		try {GregTech_API.sItemList[ 40] = new GT_NeutronReflector_Item					(GT_Mod.sItemIDs[ 40], GT_LanguageManager.mNameListItem[ 40],        0);																		} catch(Throwable e) {if (GregTech_API.DEBUG_MODE) e.printStackTrace(GT_Log.err);}
		GregTech_API.sItemList[ 41] = GregTech_API.constructElectricDrillItem			(GT_Mod.sItemIDs[ 41], GT_LanguageManager.mNameListItem[ 41],       10, 0, 2, 15.0F, 100, -1).setElectricTier(1).setBlockBreakSound(GregTech_API.sSoundList.get(107)).setEntityHitSound(GregTech_API.sSoundList.get(107));
		GregTech_API.sItemList[ 42] = GregTech_API.constructElectricDrillItem			(GT_Mod.sItemIDs[ 42], GT_LanguageManager.mNameListItem[ 42],      100, 0, 3, 45.0F, 250, -1).setElectricTier(2).setBlockBreakSound(GregTech_API.sSoundList.get(107)).setEntityHitSound(GregTech_API.sSoundList.get(107));
		GregTech_API.sItemList[ 43] = new GT_Dataorb_Item								(GT_Mod.sItemIDs[ 43], GT_LanguageManager.mNameListItem[ 43]);
		GregTech_API.sItemList[ 44] = GregTech_API.constructElectricArmorItem			(GT_Mod.sItemIDs[ 44], GT_LanguageManager.mNameListItem[ 44],    10000,   32, 1,  0, 16|32, 0.0D, false, 0, tArmorID1);
		GregTech_API.sItemList[ 45] = GregTech_API.constructElectricArmorItem			(GT_Mod.sItemIDs[ 45], GT_LanguageManager.mNameListItem[ 45],100000000, 8192, 5,  0,     0, 0.0D,  true, 1, tArmorID1);
		GregTech_API.sItemList[ 46] = GregTech_API.constructElectricDrillItem			(GT_Mod.sItemIDs[ 46], GT_LanguageManager.mNameListItem[ 46],       10, 0, 5, 3.0F, 1000, -1).setElectricTier(1).addToMaterialList(Material.anvil).addToMaterialList(Material.iron).addToMaterialList(Material.rock).setPrimaryToolClass("pickaxe").setSilkyness(3);
		try {GregTech_API.sItemList[ 47] = new GT_Teslastaff_Item						(GT_Mod.sItemIDs[ 47], GT_LanguageManager.mNameListItem[ 47]);																					} catch(Throwable e) {if (GregTech_API.DEBUG_MODE) e.printStackTrace(GT_Log.err);}
		GregTech_API.sItemList[ 48] = GregTech_API.constructRadioactiveCellItem			(GT_Mod.sItemIDs[ 48], GT_LanguageManager.mNameListItem[ 48],    25000, 1, -5, null);
		GregTech_API.sItemList[ 49] = GregTech_API.constructRadioactiveCellItem			(GT_Mod.sItemIDs[ 49], GT_LanguageManager.mNameListItem[ 49],    25000, 2, -5, null);
		GregTech_API.sItemList[ 50] = GregTech_API.constructRadioactiveCellItem			(GT_Mod.sItemIDs[ 50], GT_LanguageManager.mNameListItem[ 50],    25000, 4, -5, null);
		GregTech_API.sItemList[ 51] = GregTech_API.constructRadioactiveCellItem			(GT_Mod.sItemIDs[ 51], GT_LanguageManager.mNameListItem[ 51],    20000, 1,  2, GT_ModHandler.getIC2Item("nearDepletedUraniumCell", 4));
		GregTech_API.sItemList[ 52] = GregTech_API.constructRadioactiveCellItem			(GT_Mod.sItemIDs[ 52], GT_LanguageManager.mNameListItem[ 52],    20000, 2,  2, GT_ModHandler.getIC2Item("nearDepletedUraniumCell", 4));
		GregTech_API.sItemList[ 53] = GregTech_API.constructRadioactiveCellItem			(GT_Mod.sItemIDs[ 53], GT_LanguageManager.mNameListItem[ 53],    20000, 4,  2, GT_ModHandler.getIC2Item("nearDepletedUraniumCell", 4));
	  //GregTech_API.sItemList[ 54] = GregTech_API.constructRadioactiveCellItem			(GT_Mod.sItemIDs[ 54], GT_LanguageManager.mNameListItem[ 54],      200, 1,  0, GT_MetaItem_Cell.instance.getUnunifiedStack(2, 1));
		try {GregTech_API.sItemList[ 55] = new GT_Debug_Item							(GT_Mod.sItemIDs[ 55], GT_LanguageManager.mNameListItem[ 55]);																					} catch(Throwable e) {if (GregTech_API.DEBUG_MODE) e.printStackTrace(GT_Log.err);}
		GregTech_API.sItemList[ 56] = GregTech_API.constructElectricEnergyStorageItem	(GT_Mod.sItemIDs[ 56], GT_LanguageManager.mNameListItem[ 56],   100000,  128, 1, 56, 57).setMaxStackSize(16).setMaxDamage(0);
		GregTech_API.sItemList[ 57] = GregTech_API.constructElectricEnergyStorageItem	(GT_Mod.sItemIDs[ 57], GT_LanguageManager.mNameListItem[ 57],   100000,  128, 1, 56, 57);
		GregTech_API.sItemList[ 58] = GregTech_API.constructElectricArmorItem			(GT_Mod.sItemIDs[ 58], GT_LanguageManager.mNameListItem[ 58],   600000,  128, 1,  0,  0, 0.0D,  true, 1, tArmorID2);
	  //try {GregTech_API.sItemList[ 59] = Shield																																														} catch(Throwable e) {if (GregTech_API.DEBUG_MODE) e.printStackTrace(GT_Log.err);}
		GregTech_API.sItemList[ 60] = GregTech_API.constructCoolantCellItem				(GT_Mod.sItemIDs[ 60], GT_LanguageManager.mNameListItem[ 60],    60000, 1);
		GregTech_API.sItemList[ 61] = GregTech_API.constructCoolantCellItem				(GT_Mod.sItemIDs[ 61], GT_LanguageManager.mNameListItem[ 61],   180000, 3);
		GregTech_API.sItemList[ 62] = GregTech_API.constructCoolantCellItem				(GT_Mod.sItemIDs[ 62], GT_LanguageManager.mNameListItem[ 62],   360000, 6);
		try {GregTech_API.sItemList[ 63] = new GT_Scanner_Item							(GT_Mod.sItemIDs[ 63], GT_LanguageManager.mNameListItem[ 63]);																					} catch(Throwable e) {if (GregTech_API.DEBUG_MODE) e.printStackTrace(GT_Log.err);}
		GregTech_API.sItemList[ 64] = GregTech_API.constructCrowbarItem					(GT_Mod.sItemIDs[ 64], GT_LanguageManager.mNameListItem[ 64],  256,  6);
		GregTech_API.sItemList[ 65] = new GT_Screwdriver_Item							(GT_Mod.sItemIDs[ 65], GT_LanguageManager.mNameListItem[ 65],  256,  4, -1);
		GregTech_API.sItemList[ 66] = GregTech_API.constructWrenchItem					(GT_Mod.sItemIDs[ 66], GT_LanguageManager.mNameListItem[ 66], 1280,  8, -1);
		GregTech_API.sItemList[ 67] = GregTech_API.constructWrenchItem					(GT_Mod.sItemIDs[ 67], GT_LanguageManager.mNameListItem[ 67],  128,  4, -1);
		GregTech_API.sItemList[ 68] = GregTech_API.constructWrenchItem					(GT_Mod.sItemIDs[ 68], GT_LanguageManager.mNameListItem[ 68], 5120, 10, -1);
		GregTech_API.sItemList[ 69] = GregTech_API.constructWrenchItem					(GT_Mod.sItemIDs[ 69], GT_LanguageManager.mNameListItem[ 69],  256,  6, -1);
		GregTech_API.sItemList[ 70] = GregTech_API.constructElectricWrenchItem			(GT_Mod.sItemIDs[ 70], GT_LanguageManager.mNameListItem[ 70],   16,  0, 112);
		GregTech_API.sItemList[ 71] = GregTech_API.constructElectricWrenchItem			(GT_Mod.sItemIDs[ 71], GT_LanguageManager.mNameListItem[ 71],  128,  0, 113);
		GregTech_API.sItemList[ 72] = new GT_SoftHammer_Item							(GT_Mod.sItemIDs[ 72], GT_LanguageManager.mNameListItem[ 72],  128,  4);
		GregTech_API.sItemList[ 73] = GregTech_API.constructHardHammerItem				(GT_Mod.sItemIDs[ 73], GT_LanguageManager.mNameListItem[ 73],  128,  4);
		GregTech_API.sItemList[ 74] = GregTech_API.constructHardHammerItem				(GT_Mod.sItemIDs[ 74], GT_LanguageManager.mNameListItem[ 74],  256,  6);
		GregTech_API.sItemList[ 75] = GregTech_API.constructHardHammerItem				(GT_Mod.sItemIDs[ 75], GT_LanguageManager.mNameListItem[ 75], 1280,  8);
		GregTech_API.sItemList[ 76] = GregTech_API.constructHardHammerItem				(GT_Mod.sItemIDs[ 76], GT_LanguageManager.mNameListItem[ 76], 5120, 10);
		GregTech_API.sItemList[ 77] = GregTech_API.constructElectricSolderingToolItem	(GT_Mod.sItemIDs[ 77], GT_LanguageManager.mNameListItem[ 77],   10,  0, 114);
		GregTech_API.sItemList[ 78] = new GT_SolderingMetal_Item						(GT_Mod.sItemIDs[ 78], GT_LanguageManager.mNameListItem[ 78],   50,  0);
		GregTech_API.sItemList[ 79] = new GT_SolderingMetal_Item						(GT_Mod.sItemIDs[ 79], GT_LanguageManager.mNameListItem[ 79],   10,  0);
		GregTech_API.sItemList[ 80] = new GT_Durable_Item								(GT_Mod.sItemIDs[ 80], GT_LanguageManager.mNameListItem[ 80], "Turbine Efficiency:  60%"			, 15000);
		GregTech_API.sItemList[ 81] = new GT_Durable_Item								(GT_Mod.sItemIDs[ 81], GT_LanguageManager.mNameListItem[ 81], "Turbine Efficiency:  80%"			, 10000);
		GregTech_API.sItemList[ 82] = new GT_Durable_Item								(GT_Mod.sItemIDs[ 82], GT_LanguageManager.mNameListItem[ 82], "Turbine Efficiency: 100%"			, 10000);
		GregTech_API.sItemList[ 83] = new GT_Durable_Item								(GT_Mod.sItemIDs[ 83], GT_LanguageManager.mNameListItem[ 83], "Turbine Efficiency:  90%"			, 30000);
		GregTech_API.sItemList[ 84] = new GT_Durable_Item								(GT_Mod.sItemIDs[ 84], GT_LanguageManager.mNameListItem[ 84], "Turbine Efficiency: 125%"			,  2500);
		GregTech_API.sItemList[ 85] = new GT_Durable_Item								(GT_Mod.sItemIDs[ 85], GT_LanguageManager.mNameListItem[ 85], "Filters Lava in Thermal Boilers"	,   100);
		GregTech_API.sItemList[ 86] = new GT_File_Item									(GT_Mod.sItemIDs[ 86], GT_LanguageManager.mNameListItem[ 86],  128, 2);
		GregTech_API.sItemList[ 87] = new GT_File_Item									(GT_Mod.sItemIDs[ 87], GT_LanguageManager.mNameListItem[ 87],  256, 3);
		GregTech_API.sItemList[ 88] = new GT_File_Item									(GT_Mod.sItemIDs[ 88], GT_LanguageManager.mNameListItem[ 88], 1280, 3);
		GregTech_API.sItemList[ 89] = new GT_File_Item									(GT_Mod.sItemIDs[ 89], GT_LanguageManager.mNameListItem[ 89], 5120, 4);
		GregTech_API.sItemList[ 90] = new GT_Spray_Bug_Item								(GT_Mod.sItemIDs[ 90], GT_LanguageManager.mNameListItem[ 90],  128, 2);
		GregTech_API.sItemList[ 91] = new GT_Spray_Ice_Item								(GT_Mod.sItemIDs[ 91], GT_LanguageManager.mNameListItem[ 91],  512, 4);
		GregTech_API.sItemList[ 92] = new GT_Spray_Hardener_Item						(GT_Mod.sItemIDs[ 92], GT_LanguageManager.mNameListItem[ 92],  256, 0);
		GregTech_API.sItemList[ 93] = new GT_Spray_Foam_Item							(GT_Mod.sItemIDs[ 93], GT_LanguageManager.mNameListItem[ 93],  400, 0);
		GregTech_API.sItemList[ 94] = new GT_Spray_Pepper_Item							(GT_Mod.sItemIDs[ 94], GT_LanguageManager.mNameListItem[ 94],  128, 2);
		GregTech_API.sItemList[ 95] = new GT_Spray_Hydration_Item						(GT_Mod.sItemIDs[ 95], GT_LanguageManager.mNameListItem[ 95], 2560, 0);
		GregTech_API.sItemList[ 96] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[ 96], GT_LanguageManager.mNameListItem[ 96], 2048, 0, (byte) 0);
		GregTech_API.sItemList[ 97] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[ 97], GT_LanguageManager.mNameListItem[ 97], 2048, 0, (byte) 1);
		GregTech_API.sItemList[ 98] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[ 98], GT_LanguageManager.mNameListItem[ 98], 2048, 0, (byte) 2);
		GregTech_API.sItemList[ 99] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[ 99], GT_LanguageManager.mNameListItem[ 99], 2048, 0, (byte) 3);
		GregTech_API.sItemList[100] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[100], GT_LanguageManager.mNameListItem[100], 2048, 0, (byte) 4);
		GregTech_API.sItemList[101] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[101], GT_LanguageManager.mNameListItem[101], 2048, 0, (byte) 5);
		GregTech_API.sItemList[102] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[102], GT_LanguageManager.mNameListItem[102], 2048, 0, (byte) 6);
		GregTech_API.sItemList[103] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[103], GT_LanguageManager.mNameListItem[103], 2048, 0, (byte) 7);
		GregTech_API.sItemList[104] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[104], GT_LanguageManager.mNameListItem[104], 2048, 0, (byte) 8);
		GregTech_API.sItemList[105] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[105], GT_LanguageManager.mNameListItem[105], 2048, 0, (byte) 9);
		GregTech_API.sItemList[106] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[106], GT_LanguageManager.mNameListItem[106], 2048, 0, (byte)10);
		GregTech_API.sItemList[107] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[107], GT_LanguageManager.mNameListItem[107], 2048, 0, (byte)11);
		GregTech_API.sItemList[108] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[108], GT_LanguageManager.mNameListItem[108], 2048, 0, (byte)12);
		GregTech_API.sItemList[109] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[109], GT_LanguageManager.mNameListItem[109], 2048, 0, (byte)13);
		GregTech_API.sItemList[110] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[110], GT_LanguageManager.mNameListItem[110], 2048, 0, (byte)14);
		GregTech_API.sItemList[111] = new GT_Spray_Color_Item							(GT_Mod.sItemIDs[111], GT_LanguageManager.mNameListItem[111], 2048, 0, (byte)15);
		GregTech_API.sItemList[112] = GregTech_API.constructEmptyElectricToolItem		(GT_Mod.sItemIDs[112], GT_LanguageManager.mNameListItem[112],   16, 70);
		GregTech_API.sItemList[113] = GregTech_API.constructEmptyElectricToolItem		(GT_Mod.sItemIDs[113], GT_LanguageManager.mNameListItem[113],  128, 71);
		GregTech_API.sItemList[114] = GregTech_API.constructEmptyElectricToolItem		(GT_Mod.sItemIDs[114], GT_LanguageManager.mNameListItem[114],   10, 77);
		GregTech_API.sItemList[115] = new GT_Saw_Item									(GT_Mod.sItemIDs[115], GT_LanguageManager.mNameListItem[115],  128, 2, 2, 3.0F, 0, -1);
		GregTech_API.sItemList[116] = new GT_Saw_Item									(GT_Mod.sItemIDs[116], GT_LanguageManager.mNameListItem[116],  256, 3, 2, 4.0F, 0, -1);
		GregTech_API.sItemList[117] = new GT_Saw_Item									(GT_Mod.sItemIDs[117], GT_LanguageManager.mNameListItem[117], 1280, 4, 3, 6.0F, 0, -1);
		GregTech_API.sItemList[118] = new GT_Saw_Item									(GT_Mod.sItemIDs[118], GT_LanguageManager.mNameListItem[118], 5120, 5, 4, 8.0F, 0, -1);
		GregTech_API.sItemList[119] = GregTech_API.constructElectricSawItem				(GT_Mod.sItemIDs[119], GT_LanguageManager.mNameListItem[119],   16, 9, 3,10.0F, 100, 121).setCraftingSound(GregTech_API.sSoundList.get(104)).setBreakingSound(GregTech_API.sSoundList.get(104)).setBlockBreakSound(GregTech_API.sSoundList.get(104)).setEntityHitSound(GregTech_API.sSoundList.get(105));
		GregTech_API.sItemList[120] = GregTech_API.constructElectricSawItem				(GT_Mod.sItemIDs[120], GT_LanguageManager.mNameListItem[120],  128,12, 4,12.0F, 200, 122).setCraftingSound(GregTech_API.sSoundList.get(104)).setBreakingSound(GregTech_API.sSoundList.get(104)).setBlockBreakSound(GregTech_API.sSoundList.get(104)).setEntityHitSound(GregTech_API.sSoundList.get(105));
		GregTech_API.sItemList[121] = GregTech_API.constructEmptyElectricToolItem		(GT_Mod.sItemIDs[121], GT_LanguageManager.mNameListItem[121],   10, 119);
		GregTech_API.sItemList[122] = GregTech_API.constructEmptyElectricToolItem		(GT_Mod.sItemIDs[122], GT_LanguageManager.mNameListItem[122],   10, 120);
		GregTech_API.sItemList[123] = GregTech_API.constructElectricDrillItem			(GT_Mod.sItemIDs[123], GT_LanguageManager.mNameListItem[123],  128, 8, 5,35.0F, 250, -1).addToMaterialList(Material.anvil).addToMaterialList(Material.iron).addToMaterialList(Material.rock).setPrimaryToolClass("pickaxe").setSecondaryToolClass("shovel").setBlockBreakSound(GregTech_API.sSoundList.get(106)).setEntityHitSound(GregTech_API.sSoundList.get(106));
		GregTech_API.sItemList[124] = new GT_Vanilla_Sword								(GT_Mod.sItemIDs[124], GT_LanguageManager.mNameListItem[124], "Flint"			, 1,  5, GT_Mod.sNerfedStoneTools?128:256	,  4.0F, 1.0F);
		GregTech_API.sItemList[125] = new GT_Vanilla_Pickaxe							(GT_Mod.sItemIDs[125], GT_LanguageManager.mNameListItem[125], "Flint"			, 1,  5, GT_Mod.sNerfedStoneTools?128:256	,  4.0F, 1.0F);
		GregTech_API.sItemList[126] = new GT_Vanilla_Shovel								(GT_Mod.sItemIDs[126], GT_LanguageManager.mNameListItem[126], "Flint"			, 1,  5, GT_Mod.sNerfedStoneTools?128:256	,  4.0F, 1.0F);
		GregTech_API.sItemList[127] = new GT_Vanilla_Axe								(GT_Mod.sItemIDs[127], GT_LanguageManager.mNameListItem[127], "Flint"			, 1,  5, GT_Mod.sNerfedStoneTools?128:256	,  4.0F, 1.0F);
		GregTech_API.sItemList[128] = new GT_Vanilla_Hoe								(GT_Mod.sItemIDs[128], GT_LanguageManager.mNameListItem[128], "Flint"			, 1,  5, GT_Mod.sNerfedStoneTools?128:256	,  4.0F, 1.0F);
		GregTech_API.sItemList[129] = new GT_Vanilla_Sword								(GT_Mod.sItemIDs[129], GT_LanguageManager.mNameListItem[129], "Steel"			, 2, 14, 1280								,  8.0F, 2.0F);
		GregTech_API.sItemList[130] = new GT_Vanilla_Pickaxe							(GT_Mod.sItemIDs[130], GT_LanguageManager.mNameListItem[130], "Steel"			, 2, 14, 1280								,  8.0F, 2.0F);
		GregTech_API.sItemList[131] = new GT_Vanilla_Shovel								(GT_Mod.sItemIDs[131], GT_LanguageManager.mNameListItem[131], "Steel"			, 2, 14, 1280								,  8.0F, 2.0F);
		GregTech_API.sItemList[132] = new GT_Vanilla_Axe								(GT_Mod.sItemIDs[132], GT_LanguageManager.mNameListItem[132], "Steel"			, 2, 14, 1280								,  8.0F, 2.0F);
		GregTech_API.sItemList[133] = new GT_Vanilla_Hoe								(GT_Mod.sItemIDs[133], GT_LanguageManager.mNameListItem[133], "Steel"			, 2, 14, 1280								,  8.0F, 2.0F);
		GregTech_API.sItemList[134] = new GT_Vanilla_Sword								(GT_Mod.sItemIDs[134], GT_LanguageManager.mNameListItem[134], "TungstenSteel"	, 4,  5, 5120								, 12.0F, 3.0F);
		GregTech_API.sItemList[135] = new GT_Vanilla_Pickaxe							(GT_Mod.sItemIDs[135], GT_LanguageManager.mNameListItem[135], "TungstenSteel"	, 4,  5, 5120								, 12.0F, 3.0F);
		GregTech_API.sItemList[136] = new GT_Vanilla_Shovel								(GT_Mod.sItemIDs[136], GT_LanguageManager.mNameListItem[136], "TungstenSteel"	, 4,  5, 5120								, 12.0F, 3.0F);
		GregTech_API.sItemList[137] = new GT_Vanilla_Axe								(GT_Mod.sItemIDs[137], GT_LanguageManager.mNameListItem[137], "TungstenSteel"	, 4,  5, 5120								, 12.0F, 3.0F);
		GregTech_API.sItemList[138] = new GT_Vanilla_Hoe								(GT_Mod.sItemIDs[138], GT_LanguageManager.mNameListItem[138], "TungstenSteel"	, 4,  5, 5120								, 12.0F, 3.0F);
		
        GT_Log.out.println("GT_Mod: Hiding certain Items from NEI.");
		try {
		Class.forName("codechicken.nei.api.API");
		codechicken.nei.api.API.hideItem(GregTech_API.sBlockList[3].blockID);
		codechicken.nei.api.API.hideItem(GregTech_API.sItemList[ 4].itemID);
		codechicken.nei.api.API.hideItem(GregTech_API.sItemList[ 7].itemID);
		codechicken.nei.api.API.hideItem(GregTech_API.sItemList[15].itemID);
		codechicken.nei.api.API.hideItem(GregTech_API.sItemList[16].itemID);
		codechicken.nei.api.API.hideItem(GT_ModHandler.getIC2Item("wrench", 1).itemID);
		codechicken.nei.api.API.hideItem(GT_ModHandler.getIC2Item("electricWrench", 1).itemID);
		codechicken.nei.api.API.hideItem(GT_ModHandler.getIC2Item("chainsaw", 1).itemID);
		} catch(Throwable e) {if (GregTech_API.DEBUG_MODE) e.printStackTrace(GT_Log.err);}
		
        GT_Log.out.println("GT_Mod: Register regular Item Names.");
		for (int i = 16; i < GregTech_API.sItemList.length; i++) {
			if (GregTech_API.sItemList[i] != null) {
				GT_LanguageManager.addStringLocalization(GregTech_API.sItemList[i].getUnlocalizedName() + ".name", GT_LanguageManager.mRegionalNameListItem[i]);
			}
		}
	}
}
